#include "chdecl.h"
void CH_matchstrings(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb8;
    case 4: goto c9;
    case 5: goto cb12;
    case 6: goto c13;
    case 7: goto c14;
    case 8: goto cb18;
    case 9: goto c19;
    case 10: goto c21;
    case 11: goto c39;
    case 12: goto c42;
    case 13: goto c45;
    case 14: goto c47;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* noop */
  
/* lookup_at 4 3.0 =(2) */
  if (2 >= (ch_t = REF(3)DOT(0).value.table)->size) goto ch_notfound;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(4).value,2);
  REF(4).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 5 4 */
  if((ch_returncode = cp_table(& ch_val, REF(4).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val;
  REF(5).tsdr = & dr_table;
/* chs_lit 6 , "stdin" */
  if( !chs_lit(DEF(6),"stdin") ) goto ch_depletion;
/* chs_lit 7 , "string" */
  if( !chs_lit(DEF(7),"string") ) goto ch_depletion;
  current->ip = 3;
cb8:
/* call 3.2.2 6 7 8 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(6),
          arguments[2] = DEF(7),
          arguments[3] = DEF(8),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c9:
/* unwrap 9 8 , 2 */
  if ((ch_returncode = che_unwrap(DEF(9),DEF(8),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* chs_lit 10 , "stdout" */
  if( !chs_lit(DEF(10),"stdout") ) goto ch_depletion;
/* chs_lit 11 , "boolean" */
  if( !chs_lit(DEF(11),"boolean") ) goto ch_depletion;
  current->ip = 5;
cb12:
/* call 3.2.2 10 11 12 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(10),
          arguments[2] = DEF(11),
          arguments[3] = DEF(12),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c13:
/* unwrap 13 12 , 3 */
  if ((ch_returncode = che_unwrap(DEF(13),DEF(12),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
c14:
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* block , 4 */
  if((ch_returncode = che_block(QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 8;
cb18:
/* receive 14 9 */
  if ((ch_returncode = che_receive(DEF(14),DEF(9),sched)) != Normal)
     goto ch_raise_exception;
  return;
c19:
/* ilit 15 , 0 */
  REF(15).value.integer = 0;
  REF(15).tsdr = & dr_integer;
c21:
/* size 16 5 */
  REF(16).value.integer = REF(5).value.table->size;
  REF(16).tsdr = & dr_integer;
/* ige . 15 16 , 35 */
  if ( REF(15).value.integer >= REF(16).value.integer ) goto c35;
/* lookup_at 17 14 15 */
  if((ch_i = REF(15).value.integer) < 0 || ch_i >= (ch_t = REF(14).value
    .table)->size) goto ch_notfound;
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(17).value,ch_i);
  REF(17).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 18 17 */
  if((ch_returncode = (REF(17).tsdr->copy)(& ch_val, REF(17).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(18).tsdr)->finalize)(REF(18).value,F_DISCARD,sched);
  REF(18).value = ch_val;
  REF(18).tsdr = datarepmap[REF(17).tsdr->number];
/* lookup_at 19 5 15 */
  if((ch_i = REF(15).value.integer) < 0 || ch_i >= (ch_t = REF(5).value
    .table)->size) goto ch_notfound;
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(19).value,ch_i);
  REF(19).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 20 19 */
  if((ch_returncode = (REF(19).tsdr->copy)(& ch_val, REF(19).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).value = ch_val;
  REF(20).tsdr = datarepmap[REF(19).tsdr->number];
/* equal . 18 20 , 31 */
  if ( (REF(18).tsdr->equal)(REF(18).value,REF(20).value) ) goto c31;
/* exit , 5 */
  ch_e = handler_type__exit; ch_val = QUAL(5); goto ch_exception;
c31:
/* noop */
  
/* iadd 15 15 =(1) */
  if (!chf_iadd(DEF(15),REF(15).value.integer,1)) goto ch_depletion;
/* branch , 21 */
   goto c21;
c35:
/* boolean 21 , TRUE */
  REF(21).value.boolean = TRUE;
  REF(21).tsdr = & dr_boolean;
/* send 13 21 */
  if ((ch_returncode = che_send(DEF(13),DEF(21),sched)) != Normal)
     goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
/* branch , 14 */
   goto c14;
c39:
/* boolean 22 , FALSE */
  REF(22).value.boolean = FALSE;
  REF(22).tsdr = & dr_boolean;
/* send 13 22 */
  if ((ch_returncode = che_send(DEF(13),DEF(22),sched)) != Normal)
     goto ch_raise_exception;
/* branch , 14 */
   goto c14;
c42:
/* boolean 23 , FALSE */
  REF(23).value.boolean = FALSE;
  REF(23).tsdr = & dr_boolean;
/* send 13 23 */
  if ((ch_returncode = che_send(DEF(13),DEF(23),sched)) != Normal)
     goto ch_raise_exception;
/* branch , 14 */
   goto c14;
c45:
/* endblock */
  che_endblock(sched);
c47:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
